/*************************************************************************
 *
 *  Frexx Database
 *
 *  A simple, lightweight database 
 *
 ************************************************************************/
#ifndef __DBASE_H__
#define __DBASE_H__
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <memory.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>

#include "types.h"
#include "lists.h"

/*
** --- macros ---
*/
#define VERSION "0.6"
#define eatspace(_xx_) while (isspace(_xx_)) _xx_++;
#define DB_TEMPLATE_EXTENSION	".tem"
#define DB_FILE_EXTENSION 	".db"
#define DB_IDFILE_EXTENSION	".id"
#define DB_BAK_EXTENSION	".bak"

/*
** --- global variables ---
*/
extern LIST dbTemplate;
extern LIST rowList;

/*
** --- type definitions ---
*/
typedef enum { unassigned, integer, string, binary } t_fieldType;
typedef enum { text, url, html } t_textType;

typedef struct {
    LIST_NODE node;
    t_fieldType type;
    int  maxlen;
    char name[80];
    char desc[256];
} t_fieldTemplate;

typedef struct {
    LIST_NODE node;
    t_fieldTemplate* template;
    int      len;
    unsigned int   value;
    unsigned char* data;
} t_field;

typedef struct {
    LIST_NODE node;
    LIST fieldList;
    unsigned long id1;
    unsigned long id2;
} t_row;


/*
** -- help function prototypes -- 
*/
int filesize( char* filename );
int writerow( FILE* file, char* filename, t_row* row );
t_field* getfield( t_row* row, char* name );
int readtemplate( char* filename );
int readdb( char* database );
int print_row( t_row *row, char* format, t_textType textMode );

char* url2string( char* string );
char* string2url( char* url );

#endif
